<template>
  <Head title="Profile" />

  <Layout>
    <div class="max-w-full mx-auto sm:px-2 lg:px-2">
      <div class="lg:flex lg:items-center lg:justify-between py-4">
        <div class="flex-1 min-w-0">
          <!-- {/* Title Page */} -->
          <h2
            class="
              text-2xl
              font-semibold
              text-gray-700
              dark:text-gray-200
              sm:text-3xl sm:truncate
            "
          >
            Profile
          </h2>
          <!-- {/* Breadcumb */} -->
          <div
            class="
              mt-1
              flex flex-col
              sm:flex-row sm:flex-wrap sm:mt-0 sm:space-x-6
            "
          >
            <ul class="flex text-gray-900 text-sm lg:text-base">
              <li class="inline-flex items-center">
                <Link :href="route('dashboard')">Dashboard</Link>
                <svg
                  class="h-5 w-auto text-gray-400"
                  fill="currentColor"
                  viewBox="0 0 20 20"
                >
                  <path
                    fillRule="evenodd"
                    d="M7.293 14.707a1 1 0 010-1.414L10.586 10 7.293 6.707a1 1 0 011.414-1.414l4 4a1 1 0 010 1.414l-4 4a1 1 0 01-1.414 0z"
                    clipRule="evenodd"
                  ></path>
                </svg>
              </li>
              <li class="inline-flex items-center">
                <a href="#" class="text-gray-500"> Profile </a>
              </li>
            </ul>
          </div>
        </div>
        <div class="mt-5 flex lg:mt-0 lg:ml-4"></div>
      </div>

      <div class="w-full overflow-hidden rounded-lg shadow-xs">
        <form @submit.prevent="onSubmit">
          <div class="grid grid-cols-4 gap-4">
            <!-- Left Side -->
            <div class="w-full">
              <!-- Profile Card -->
              <div class="bg-white p-3 border-t-4 border-red-400">
                <div class="image overflow-hidden">
                  <img class="h-auto w-full mx-auto" :src="form.photo" alt="" />
                </div>
                <h1 class="text-gray-900 font-bold text-xl leading-8 my-1">
                  {{ $page.props.auth.user.name }}
                </h1>
                <h3 class="text-gray-600 font-lg text-semibold leading-6">
                  {{ $page.props.auth.user.name }}
                </h3>
                <p class="text-sm text-gray-500 hover:text-gray-600 leading-6">
                  Lorem ipsum dolor sit amet consectetur adipisicing elit.
                  Reprehenderit, eligendi dolorum sequi illum qui unde
                  aspernatur non deserunt
                </p>
                <ul
                  class="
                    bg-gray-100
                    text-gray-600
                    hover:text-gray-700 hover:shadow
                    py-2
                    px-3
                    mt-3
                    divide-y
                    rounded
                    shadow-sm
                  "
                >
                  <li class="flex items-center py-3">
                    <span>Status</span>
                    <span class="ml-auto"
                      ><span
                        class="
                          bg-green-500
                          py-1
                          px-2
                          rounded
                          text-white text-sm
                        "
                        >Active</span
                      ></span
                    >
                  </li>
                  <li class="flex items-center py-3">
                    <span>Member since</span>
                    <span class="ml-auto">
                      <!-- Nov 07, 2016 -->
                      <!-- {{ form.created_at }} -->
                      {{ SetDateTime($page.props.auth.user.created_at) }}
                    </span>
                  </li>
                </ul>
              </div>
              <!-- End of profile card -->
              <div class="my-4"></div>
            </div>

            <div class="col-span-3">
              <!-- Right Side -->
              <div class="w-full border-t-4 border-red-400">
                <!-- Information Section -->
                <div class="bg-white p-3 shadow-sm rounded-sm">
                  <div
                    class="
                      flex
                      items-center
                      space-x-2
                      font-semibold
                      text-gray-900
                      leading-8
                    "
                  >
                    <Icon :name="`user`" :style="`h-5`" />
                    <span class="tracking-wide">Informasi Profil</span>
                  </div>

                  <div class="grid mt-2 md:grid-cols-2 text-gray-700 text-sm">
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Nama Awal</div>
                      <div class="px-4">
                        <Input
                          id="firstname"
                          type="text"
                          :class="
                            form.errors.firstname
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          v-model="form.firstname"
                        />
                        <div
                          v-if="form.errors.firstname"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.firstname }}
                        </div>
                      </div>
                    </div>

                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Nama AKhir</div>
                      <div class="px-4">
                        <Input
                          id="lastname"
                          type="text"
                          :class="
                            form.errors.lastname
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          v-model="form.lastname"
                        />
                      </div>
                    </div>
                  </div>

                  <div class="grid py-2 md:grid-cols-2 text-gray-700 text-sm">
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Propinsi</div>
                      <div class="px-4">
                        <Multiselect
                          v-model="form.province_id"
                          :options="provinces"
                          :close-on-select="true"
                          :clear-on-select="false"
                          @select="onSeledtedProvince"
                          placeholder="Pilih Propinsi"
                          label="name"
                          track-by="id"
                        ></Multiselect>
                        <div
                          v-if="form.errors.province_id"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.province_id }}
                        </div>
                      </div>
                    </div>
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Kota</div>
                      <div class="px-4">
                        <Multiselect
                          v-model="form.city_id"
                          :options="cities"
                          :close-on-select="true"
                          :clear-on-select="false"
                          @select="onSeledtedCity"
                          placeholder="Pilih Kota"
                          label="name"
                          track-by="id"
                        ></Multiselect>

                        <div
                          v-if="form.errors.city_id"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.city_id }}
                        </div>
                      </div>
                    </div>
                  </div>

                  <div class="grid py-2 md:grid-cols-2 text-gray-700 text-sm">
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Kelurahan</div>
                      <div class="px-4">
                        <Multiselect
                          v-model="form.district_id"
                          :options="districts"
                          :close-on-select="true"
                          :clear-on-select="false"
                          @select="onSeledtedDistrict"
                          placeholder="Pilih Kelurahan"
                          label="name"
                          track-by="id"
                        ></Multiselect>

                        <div
                          v-if="form.errors.district_id"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.district_id }}
                        </div>
                      </div>
                    </div>
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Kecamatan</div>
                      <div class="px-4">
                        <Multiselect
                          v-model="form.village_id"
                          :options="villages"
                          :close-on-select="true"
                          :clear-on-select="false"
                          placeholder="Pilih Kecamatan"
                          label="name"
                          track-by="id"
                        ></Multiselect>

                        <div
                          v-if="form.errors.village_id"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.village_id }}
                        </div>
                      </div>
                    </div>
                  </div>

                  <div class="grid py-2 md:grid-cols-2 text-gray-700 text-sm">
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Current Address</div>
                      <div class="px-4">
                        <textarea
                          id="name"
                          type="text"
                          :class="
                            form.errors.current_address
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          v-model="form.current_address"
                        ></textarea>

                        <div
                          v-if="form.errors.current_address"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.current_address }}
                        </div>
                      </div>
                    </div>
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">
                        Permanant Address
                      </div>
                      <div class="px-4">
                        <textarea
                          id="name"
                          type="text"
                          :class="
                            form.errors.permanent_address
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          v-model="form.permanent_address"
                        ></textarea>

                        <div
                          v-if="form.errors.permanent_address"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.permanent_address }}
                        </div>
                      </div>
                    </div>
                  </div>

                  <div
                    class="grid mt-2 mb-5 md:grid-cols-2 text-gray-700 text-sm"
                  >
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">Kode Pos</div>
                      <div class="px-4">
                        <Input
                          id="name"
                          type="text"
                          :class="
                            form.errors.postal_code
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          v-model="form.postal_code"
                        />

                        <div
                          v-if="form.errors.postal_code"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.postal_code }}
                        </div>
                      </div>
                    </div>
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold">No Handphone</div>
                      <div class="px-4">
                        <Input
                          id="name"
                          type="text"
                          :class="
                            form.errors.mobile_phone
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          v-model="form.mobile_phone"
                        />

                        <div
                          v-if="form.errors.mobile_phone"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.mobile_phone }}
                        </div>
                      </div>
                    </div>
                    <div class="grid grid-cols-1 mt-2">
                      <div class="px-4 py-2 font-semibold">Photo</div>
                      <div class="px-4">
                        <!-- <input type="file" @input="form.photo = $event.target.files[0]" /> -->
                        <input
                          type="file"
                          :class="
                            form.errors.photo
                              ? 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                              : 'flex-1 block w-full rounded-none rounded-r-md sm:text-sm focus:ring-yellow-500 focus:border-yellow-500 border-gray-300 block w-full'
                          "
                          @change="updatePhotoPreview"
                          @input="form.photo = $event.target.files[0]"
                        />
                        <!-- @change="updatePhotoPreview" -->
                        <!-- @input="form.photo = $event.target.files[0]" -->
                        <div
                          v-if="form.errors.photo"
                          className="py-1 text-red-600 text-sm font-medium"
                        >
                          {{ form.errors.photo }}
                        </div>
                      </div>
                    </div>
                    <div class="grid grid-cols-1">
                      <div class="px-4 py-2 font-semibold"></div>
                      <div class="px-4">
                        <progress
                          v-if="form.progress"
                          :value="form.progress.percentage"
                          max="100"
                        >
                          {{ form.progress.percentage }} %
                        </progress>
                      </div>
                    </div>
                  </div>

                  <div class="px-4 py-3 flex justify-end">
                    <Button
                      class="ml-4"
                      :class="{ 'opacity-25': form.processing }"
                      :disabled="form.processing"
                    >
                      <Icon :name="`save`" :style="`-ml-1 mr-2 h-5 w-5`" />
                      Save
                    </Button>
                  </div>
                </div>
                <!-- End of about section -->

                <div class="my-4"></div>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
  </Layout>
</template>

<script>
import { ref, reactive, onMounted } from "vue";
import Layout from "@/Layouts/App.vue";
import { Head, Link, useForm, usePage } from "@inertiajs/inertia-vue3";
import { Inertia } from "@inertiajs/inertia";
import Multiselect from "@suadelabs/vue3-multiselect";
import Button from "@/Components/Button.vue";
import Icon from "@/Components/Icon";
import Input from "@/Components/Input.vue";
import Label from "@/Components/Label.vue";
import moment from "moment";

export default {
  components: {
    Layout,
    Head,
    Link,
    Button,
    Icon,
    Input,
    Label,
    Multiselect,
    Inertia,
    moment,
  },
  props: {
    filters: Object,
    user_address: {
      type: Object,
      default: () => null,
    },
    member_since: {
      type: String,
      default: () => null,
    },
    provinces: {
      type: Array,
      default: () => [],
    },
    cities: {
      type: Array,
      default: () => [],
    },
    districts: {
      type: Array,
      default: () => [],
    },
    villages: {
      type: Array,
      default: () => [],
    },
    // hasProvince: Object,
  },
  setup(props) {
    let params = reactive({
      province: props.filters.province || null,
      city: props.filters.city || null,
      district: props.filters.district || null,
    });

    const form = useForm({
      firstname: null,
      lastname: null,
      province_id: null,
      city_id: null,
      district_id: null,
      village_id: null,
      current_address: null,
      permanent_address: null,
      postal_code: null,
      mobile_phone: null,
      photo: null,
      previewPhoto: null,
    });

    const address = usePage().props.value.user_address || null;
    // console.log(address)

    // if (address) {
    form.firstname = address ? address.firstname : null;
    form.lastname = address ? address.lastname : null;
    form.province_id = address ? address.province : null;
    form.city_id = address ? address.city : null;
    form.district_id = address ? address.district : null;
    form.village_id = address ? address.village : null;
    form.current_address = address ? address.current_address : null;
    form.permanent_address = address ? address.permanent_address : null;
    form.postal_code = address ? address.postal_code : null;
    form.mobile_phone = address ? address.mobile_phone : null;
    form.created_at = address ? address.created_at : null;
    form.photo = null;
    if (address) {
      form.previewPhoto = address.photo
        ? "/storage/images/" + address.photo
        : "https://via.placeholder.com/150";
    }

    let onSeledtedProvince = (province) => {
      params.province = province.id;
      form.city_id = null;
      form.district_id = null;
      form.village_id = null;

      Inertia.get(route("profile"), params, {
        preserveState: true,
        preserveScroll: true,
        replace: true,
        onSuccess: () => {
          console.log("ok province");
        },
      });
    };

    let updatePhotoPreview = (e) => {
      form.previewPhoto = URL.createObjectURL(e.target.files[0]);
    };

    let onSeledtedCity = (city) => {
      params.city = city.id;
      Inertia.get(
        route("profile"),
        // { city: city.id },
        params,
        {
          preserveState: true,
          preserveScroll: true,
          replace: true,
        }
      );
    };

    let onSeledtedDistrict = (district) => {
      params.district = district.id;
      Inertia.get(
        route("profile"),
        // { district: district.id },
        params,
        {
          preserveState: true,
          preserveScroll: true,
          replace: true,
        }
      );
    };

    let onSubmit = () => {
      form.post(route("profile.store"), {
        preserveScroll: true,
        forceFormData: true,
        onSuccess: () => {
          console.log("reset default");
        },
      });
    };

    let SetDateTime = (value) => {
      return moment(value).format("MMMM d, YYYY");
    };

    return {
      form,
      onSubmit,
      onSeledtedProvince,
      onSeledtedCity,
      onSeledtedDistrict,
      params,
      SetDateTime,
      updatePhotoPreview,
    };
  },
};
</script>
